NorthWind.WebMVC/Models/ProductViewModel.cs
using NorthWind.Entity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace NorthWind.WebMVC.Models
{
    public class ProductViewModel
    {
        public int State { get; set; }

        public Products Products { get; set; }

        public Categories Category { get; set; }

        public Suppliers Supplier { get; set; }

        public List<Categories> CategoryList { get; set; }

    }
}

NorthWind.WebMVC/Controllers/CategoriesController.cs
using DataTables.Mvc;
using NorthWind.Facade;
using NorthWind.WebMVC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
namespace NorthWind.WebMVC.Controllers
{
    [Authorize]
    public class CategoriesController : Controller
    {
        // GET: Categories
        public ActionResult Index()
        {
            return View();
        }

        // GET: Categories/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Categories/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Categories/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Categories/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Categories/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Categories/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Categories/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        } 

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new CategoryFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim();
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);

            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Controllers/ProductsController.cs
using DataTables.Mvc;
using NorthWind.Entity;
using NorthWind.Facade;
using NorthWind.WebMVC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace NorthWind.WebMVC.Controllers
{
    [Authorize]
    public class ProductsController : Controller
    {
        // GET: Products
        public ActionResult Index()
        {
            return View();
        }

        // GET: Products/Details/5
        public ActionResult Details(int id)
        {
            var facade = new ProductsFacade();
            var obj = facade.GetItemByID(id);
            var ctg = new CategoryFacade().GetItemByID(obj.CategoryID);
            var supp = new SupplierFacade().GetItemByID(obj.SupplierID);
            var model = new ProductViewModel() { State=1, Products = obj, Category = ctg, Supplier = supp};
            return PartialView("_Details", model);
        }

        // GET: Products/Create
        public ActionResult Create()
        {
            var obj = new Products();
            var ctg = new Categories();
            var supp = new Suppliers();
            var model = new ProductViewModel { State = 0, Products = obj , Category = ctg, Supplier = supp };
            return PartialView("_Create", model);
        }

        // POST: Products/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Products/Edit/5
        public ActionResult Edit(int id)
        {
            var facade = new ProductsFacade();
            var obj = facade.GetItemByID(id);
            var ctg = new CategoryFacade().GetItemByID(obj.CategoryID);
            var supp = new SupplierFacade().GetItemByID(obj.SupplierID);
            var list = new CategoryFacade().GetAllItems();
            var model = new ProductViewModel() { State = 2, Products = obj, Category = ctg, Supplier = supp, CategoryList = list };
            return PartialView("_Edit", model);
        }

        
        [HttpPost]
        public async Task<ActionResult> Edit(ProductViewModel model)
        {
            string errMsg = string.Empty;
            try
            {
                var facade = new ProductsFacade();
                bool status = facade.DataUpdate(model.Products.ProductID, model.Products, out errMsg);
                await Task<bool>.Factory.StartNew(() => status);
                if (!status)
                {
                    ModelState.AddModelError("", "Update data error \n, Error: " + errMsg);
                    return View("_Edit", model);
                }
                if (Request.IsAjaxRequest())
                {
                    return Content("success");
                }
            }
            catch
            {
                return View();
            }
            
            return RedirectToAction("Index");
        }

        // GET: Products/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Products/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new ProductsFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim(); 
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);
            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Controllers/SuppliersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DataTables.Mvc;
using NorthWind.Facade;
using NorthWind.WebMVC.Models;

namespace NorthWind.WebMVC.Controllers
{
    [Authorize]
    public class SuppliersController : Controller
    {
        // GET: Suppliers
        public ActionResult Index()
        {
            return View();
        }

        // GET: Suppliers/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Suppliers/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Suppliers/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Suppliers/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Suppliers/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Suppliers/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Suppliers/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new SupplierFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim();
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);

            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Views/Products/Index.cshtml
@{
    ViewBag.Title = "Index";
}

<div class="row">
    <div class="col-md-12">
        <h2>
            Product List
        </h2>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <div class="pull-right" style="margin-bottom: 10px">
            <button type="button" onclick="showCreate()" class="btn btn-primary btn-sm"><i class="glyphicon glyphicon-plus"></i> Add New</button>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <table id="product-dt" class="table table-striped table-bordered"></table> 
    </div> 
</div>

<div id="modal-container" class="modal fade" data-backdrop="static"></div>

@section scripts{
    <script type="text/javascript">
        var lengthMenu = [[10, 25, 50, 100], [10, 25, 50, 100]];
        var productdt; 
        $(function () {
            productdt = {
                dt: null,
                init: function () {
                    dt = $('#product-dt').DataTable({
                        serverSide: true,
                        processing: true,
                        ajax: {
                            url: "@Url.Action("Get", "Products")"
                        },
                        aaSorting: [[1, 'asc']],
                        columns: [
                            {
                                data: 'ProductID',
                                sortable: false,
                                render: function (data, type, full, meta) {
                                    return '<a id="btnDetail" href="javascript:showDetail(' + data + ')"><i class="glyphicon glyphicon-search"></i></a>' +
                                        '<a id="btnEdit" href="javascript:showEdit(' + data + ')" style="color: green; margin-left: 5px"><i class="glyphicon glyphicon-edit"></i></a>' +
                                        '<a id="btnDetail" href="javascript:deleteData(' + data + ')" style="color: red; margin-left: 5px"><i class="glyphicon glyphicon-remove"></i></a>';
                                }
                            },
                            { title: 'Product ID', data: 'ProductID' },
                            { title: 'Product Name', data: 'ProductName' }, 
                            { title: 'Supplier', data: 'CompanyName' },
                            { title: 'Category', data: 'CategoryName' }, 
                            { title: 'Quantity Pe rUnit', data: 'QuantityPerUnit' },
                            { title: 'UnitPrice', data: 'UnitPrice' }
                        ],
                        lengthMenu: lengthMenu
                    });
                },
                refresh: function () {
                    dt.ajax.reload();
                }
            };
            
            productdt.init(); 
        });

        function showDetail(id) {
            $.get("Products/Details/"+id, function (data) {
                $('#modal-container').html(data);
                $('#modal-container').modal();
            }); 
        }
        function showEdit(id) {
            $.get("Products/Edit/" + id, function (data) {
                $('#modal-container').html(data);
                $('#modal-container').modal();
            }); 
        }

        function showCreate() {
            $.get("Products/Create", function (data) {
                $('#modal-container').html(data);
                $('#modal-container').modal();
            }); 
        }

        function OnSuccess(data) {
            if (data !== 'success') {
                $("#modal-container").html(data);
                return;
            }
            $("#modal-container").modal('hide');
            $("#modal-container").html("");
            productdt.refresh();
        }

        function deleteData(id){
            
        }

    </script>
}

@*Lookup Category*@
@Html.Action("Lookup", "Categories")

@*Lookup Supplier*@
@Html.Action("Lookup", "Suppliers")

NorthWind.WebMVC/Views/Products/_Create.cshtml
@model NorthWind.WebMVC.Models.ProductViewModel
@{
    var htmlAttr1 = new { @class = "form-control" };
}
@using (Ajax.BeginForm("Create", "Products", new AjaxOptions { HttpMethod = "POST", OnSuccess = "OnSuccess" }))
{    
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <span class="close" data-dismiss="modal">&times;</span>
                Product Detail
            </div>
            <div class="modal-body">
                <div class="form-horizontal">
                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    <div class="form-group">
                        <label class="control-label col-md-3">Product ID</label>
                        <div class="col-md-3">@Html.TextBoxFor(model => model.Products.ProductID, new { @readonly = true, @class = "form-control" })</div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Product Name</label>
                        <div class="col-md-8">
                            @Html.TextBoxFor(model => model.Products.ProductName, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.ProductName, "", new { @class = "text-danger" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Category</label>
                        <div class="col-md-8">
                            <div class="input-group">
                                @Html.HiddenFor(model => model.Products.CategoryID)
                                @Html.ValidationMessageFor(model => model.Products.CategoryID, "", new { @class = "text-danger" })
                                @Html.TextBoxFor(model => model.Category.CategoryName, new { @class = "form-control freeze" })
                                <div class="input-group-btn">
                                    <button type="button" onclick="lookupCtg()" class="btn btn-primary">
                                        <i class="glyphicon glyphicon-search"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Supplier</label>
                        <div class="col-md-8">
                            <div class="input-group">
                                @Html.HiddenFor(model => model.Products.SupplierID)
                                @Html.ValidationMessageFor(model => model.Products.SupplierID, "", new { @class = "text-danger" })
                                @Html.TextBoxFor(model => model.Supplier.CompanyName, new { @class = "form-control freeze" })
                                <div class="input-group-btn">
                                    <button class="btn btn-primary" type="button" onclick="lookupSupp()">
                                        <i class="glyphicon glyphicon-search"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Unit Price</label>
                        <div class="col-md-3">
                            @Html.TextBoxFor(model => model.Products.UnitPrice, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.UnitPrice, "", new { @class = "text-danger" })
                        </div>
                        <label class="control-label col-md-2">Quantity Per Unit</label>
                        <div class="col-md-3">
                            @Html.TextBoxFor(model => model.Products.QuantityPerUnit, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.QuantityPerUnit, "", new { @class = "text-danger" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Units In Stock</label>
                        <div class="col-md-3">
                            @Html.TextBoxFor(model => model.Products.UnitsInStock, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.UnitsInStock, "", new { @class = "text-danger" })
                        </div>
                        <label class="control-label col-md-2">Units On Order</label>
                        <div class="col-md-3">
                            @Html.TextBoxFor(model => model.Products.UnitsOnOrder, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.UnitsOnOrder, "", new { @class = "text-danger" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Reorder Level</label>
                        <div class="col-md-3">
                            @Html.TextBoxFor(model => model.Products.ReorderLevel, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.ReorderLevel, "", new { @class = "text-danger" })
                        </div>
                        <label class="control-label col-md-2">Discontinued</label>
                        <div class="col-md-3">
                            <div class="checkbox">
                                <label>@Html.CheckBoxFor(model => model.Products.Discontinued)</label>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="submit" class="btn btn-primary"><i class="glyphicon glyphicon-save"></i> Save</button>
                <button type="button" class="btn btn-default" data-dismiss="modal"><i class="glyphicon glyphicon-remove"></i> Close</button>
            </div>
        </div>
    </div>
}

<script type="text/javascript">
    $('.freeze').keydown(function () { return false; });
</script>

NorthWind.WebMVC/Views/Products/_Edit.cshtml
@model NorthWind.WebMVC.Models.ProductViewModel
@{
    var htmlAttr1 = new { @class = "form-control" };
}
@using (Ajax.BeginForm("Edit", "Products", new AjaxOptions { HttpMethod = "POST", OnSuccess = "OnSuccess" }))
{
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <span class="close" data-dismiss="modal">&times;</span>
                Product Detail
            </div>
            <div class="modal-body">
                <div class="form-horizontal">
                    @Html.ValidationSummary(true, "", new { @class = "text-danger" }) 
                    <div class="form-group">
                        <label class="control-label col-md-3">Product ID</label>
                        <div class="col-md-3">@Html.TextBoxFor(model => model.Products.ProductID, new { @readonly = true, @class = "form-control" })</div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Product Name</label>
                        <div class="col-md-8">
                            @Html.TextBoxFor(model => model.Products.ProductName, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.ProductName, "", new { @class = "text-danger" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Category</label>
                        <div class="col-md-8">
                            <div class="input-group">
                                @Html.HiddenFor(model => model.Products.CategoryID)
                                @Html.ValidationMessageFor(model => model.Products.CategoryID, "", new { @class = "text-danger" })
                                @Html.TextBoxFor(model => model.Category.CategoryName, new { @class="form-control freeze"})
                                <div class="input-group-btn">
                                    <button type="button" onclick="lookupCtg()" class="btn btn-primary">
                                        <i class="glyphicon glyphicon-search"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Supplier</label>
                        <div class="col-md-8">
                            <div class="input-group">
                                @Html.HiddenFor(model => model.Products.SupplierID)
                                @Html.ValidationMessageFor(model => model.Products.SupplierID, "", new { @class = "text-danger" })
                                @Html.TextBoxFor(model => model.Supplier.CompanyName, new { @class = "form-control freeze" })
                                <div class="input-group-btn">
                                    <button class="btn btn-primary" type="button" onclick="lookupSupp()">
                                        <i class="glyphicon glyphicon-search"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Unit Price</label>
                        <div class="col-md-3">@Html.TextBoxFor(model => model.Products.UnitPrice, htmlAttr1) 
                        @Html.ValidationMessageFor(model => model.Products.UnitPrice, "", new { @class = "text-danger" })</div>
                        <label class="control-label col-md-2">Quantity Per Unit</label>
                        <div class="col-md-3">@Html.TextBoxFor(model => model.Products.QuantityPerUnit, htmlAttr1)
                        @Html.ValidationMessageFor(model => model.Products.QuantityPerUnit, "", new { @class = "text-danger" })</div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Units In Stock</label>
                        <div class="col-md-3">@Html.TextBoxFor(model => model.Products.UnitsInStock, htmlAttr1)
                        @Html.ValidationMessageFor(model => model.Products.UnitsInStock, "", new { @class = "text-danger" })</div>
                        <label class="control-label col-md-2">Units On Order</label>
                        <div class="col-md-3">
                            @Html.TextBoxFor(model => model.Products.UnitsOnOrder, htmlAttr1)
                            @Html.ValidationMessageFor(model => model.Products.UnitsOnOrder, "", new { @class = "text-danger" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="control-label col-md-3">Reorder Level</label>
                        <div class="col-md-3">@Html.TextBoxFor(model => model.Products.ReorderLevel, htmlAttr1)
                        @Html.ValidationMessageFor(model => model.Products.ReorderLevel, "", new { @class = "text-danger" })
                        </div>
                        <label class="control-label col-md-2">Discontinued</label>
                        <div class="col-md-3">
                            <div class="checkbox">
                                <label>@Html.CheckBoxFor(model => model.Products.Discontinued)</label>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="submit" class="btn btn-primary"><i class="glyphicon glyphicon-save"></i> Save</button>
                <button type="button" class="btn btn-default" data-dismiss="modal"><i class="glyphicon glyphicon-remove"></i> Close</button>
            </div>
        </div>
    </div>
}

<script type="text/javascript"> 
    $('.freeze').keydown(function () { return false; });
</script>

NorthWind.WebMVC/Views/Products/_Lookup.cshtml
<div id="lookup-prod" class="modal fade" data-backdrop="static">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <span class="close" onclick="$('#lookup-prod').modal('hide')">&times;</span>
                Select Customer
            </div>
            <div class="modal-body">
                <table id="table-lookup-prod" class="table table-striped table-bordered" style="width: 100%"></table>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" onclick="$('#lookup-prod').modal('hide')"><i class="glyphicon glyphicon-remove"></i> Close</button>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    var lookupcus = $("#table-lookup-prod").DataTable({
                        serverSide: true,
                        processing: true,
                        scrollX: true,
                        ajax: {
                            url: "@Url.Action("Get", "Products")"
                        },
                        aaSorting: [[1, 'asc']],
                        columns: [
                            {
                                data: 'ProductID', render: function () {
                                    return '<a href="javascript:" onclick="selectProd(this)"><i class="glyphicon glyphicon-ok"></i></a>';
                                },
                                sortable: false
                            },
                            { title: 'ProductID', data: 'ProductID' },
                            { title: 'Product Name', data: 'ProductName' },
                            { title: 'Quantity PerUnit', data: 'QuantityPerUnit' },
                            { title: 'Unit Price', data: 'UnitPrice' },
                            { title: 'Units In Stock', data: 'UnitsInStock' },
                            { title: 'Units On Order', data: 'UnitsOnOrder' },
                            { title: 'Discontinued', data: 'Discontinued' }
                        ],
                        lengthMenu: [[5, 10, 25, 50, 100], [5, 10, 25, 50, 100]]
                    });

    function selectProd(e) {
        var tr = $(e).parent().parent();
        $("#ProductID").val(tr.children("td:eq(1)").text());
        $("#ProductName").val(tr.children("td:eq(2)").text());
        $("#lookup-prod").modal('hide');
    }
</script>